/* InnoTek Flash 5 release 5 (or higher) installation                        */
/*                                                                           */
/* Place the following file here: flashos2.exe                               */
/* Be sure the version you are using is CID enabled (type flashos2 /version) */
/* Please not: older versions are not supported any more by this script      */
/* If you still try them your installation will hang...                      */
/* Do not forget to register at http://www.innotek.de !!!                    */
/*                                                                           */
/* 02.15.2002: changed to work with Flash 5                                  */
/* 05.24.2002: added support for uninstallation                              */
/* 06.08.2002: fixed hang when plugins dir were missing                      */
/* 08.23.2002: added path un/installation option                             */
/* 11.15.2002: changed code to support CID installation                      */

parse arg target source mode

/* get additional parameters from environment */
product_log       = value("PRODUCT_LOG"      , ,"OS2ENVIRONMENT")
product_drv       = value("PRODUCT_DRV"      , ,"OS2ENVIRONMENT")
product_path      = value("PRODUCT_PATH"     , ,"OS2ENVIRONMENT")
inst_dir          = value("INST_DIR"         , ,"OS2ENVIRONMENT")
NS_DIR            = value("NS_DIR"           , ,"OS2ENVIRONMENT")

/* check if we are in uninstall mode */
if mode = 'UNINSTALL' then do
	call uninstall
	exit
end

/* exit if package does not exist */
if stream(inst_dir'\flashos2.exe', 'c', 'query exists') = '' then exit 9

/* install */
inst_dir'\flashos2.exe /d='product_drv'\'product_path' /update=yes /wps=yes /browsers='NS_DIR'\program\plugins >> 'product_log' 2>>&1'

exit

/* create object */
CreateObject: procedure expose product_log
    Parse Arg Class, Title, Location, Setup, Collision
    'echo Registering Object ['Title'] >> 'product_log
    rc = SysCreateObject( Class, Title, Location, Setup, Collision )
    If rc <> 1 Then
        'echo Registering Object ['Title' ^| 'Class'] in ['Location'] did not work >> 'product_log
return rc

/* uninstall mode */
uninstall:

	/* destroy objects */
	call RxFuncAdd 'SysDestroyObject', 'RexxUtil', 'SysDestroyObject'
	call SysDestroyObject "<INNOTEK_FLASH>"

	/* delete from ini */
	call RxFuncAdd 'SysIni', 'RexxUtil', 'SysIni'
	rc = SysIni('USER', 'InnoTek_Flash', 'DELETE:')

	/* del files */
	'call 'source'\updcd\bin\unlock.exe 'NS_DIR'\Program\PlugIns\npswf2.dll'
	'call 'source'\updcd\bin\unlock.exe 'product_drv'\'product_path'\npswf2.exe'
	'call 'source'\updcd\bin\unlock.exe 'product_drv'\'product_path'\flash5.exe'
	'call 'source'\updcd\bin\unlock.exe 'product_drv'\'product_path'\nsIFlash.xpt'
	'del 'NS_DIR'\Program\PlugIns\npswf2.dll'
	'del 'product_drv'\'product_path'\npswf2.dll'
	'del 'product_drv'\'product_path'\flash5.exe'
	'del 'product_drv'\'product_path'\nsIFlash.xpt'
	'del 'product_drv'\'product_path'\readme.txt'
	'del 'product_drv'\'product_path'\license.txt'
	'del 'product_drv'\'product_path'\flashdel.cmd'
	'rmdir 'product_drv'\'product_path

return
