/* Postprocessing script, runs after the installation of the add-on products */
/* 10.11.2001: added move CDrecord/2 folder                                  */
/* 05.18.2002: added move pmview & sysbar folders                            */
/* 05.25.2002: added support for uninstallation                              */
/* 06.11.2002: removed unused path variable                                  */
/* 07.08.2002: added move Mozilla folder                                     */
/* 08.14.2002: added move Odin folder                                        */
/* 12.01.2002: Destroy get Netscape URL is not needed any more               */
/* 12.14.2002: added move OpenChat folder                                    */
/* 29.08.2003: added move Pmview 3.0 folder                                  */
/* 29.10.2003: added move JAVA 1.4 folder                                    */

parse arg target source mode

/* get additional parameters from environment */
product_log       = value("PRODUCT_LOG"      , ,"OS2ENVIRONMENT")
inst_dir          = value("INST_DIR"         , ,"OS2ENVIRONMENT")

/* check if we are in uninstall mode */
if mode = 'UNINSTALL' then do
	call uninstall
	exit
end

/* add installer icons */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

/* Move icons from Desktop to different folders */
instpath = 'warpsrv'
if stream(source'\'instpath'\coninst.exe', 'c', 'query exists') = '' then instpath = 'grpware'
if stream(source'\'instpath'\coninst.exe', 'c', 'query exists') = '' then instpath = 'ibminst'
if instpath = 'ibminst' then target_folder = '<WP_APPSFOLDER>'
else target_folder = '<WP_OS2SYS>'

rc = SysMoveObject('<WARPIN_FOLDER>',    target_folder) 
'echo Moving Warp-In folder to Applications folder rc = 'rc' >> 'product_log
rc = SysMoveObject('<Sym_NAV>',          target_folder) 
'echo Moving NAV/2 folder to Applications folder rc = 'rc'   >> 'product_log
rc = SysMoveObject('<ACROBAT>',          target_folder) 
'echo Moving Acrobat folder to Applications folder rc = 'rc' >> 'product_log
rc = SysMoveObject('<FC2_FOLDER>',       target_folder) 
'echo Moving FC/2 folder to Applications folder rc = 'rc'    >> 'product_log
rc = SysMoveObject('<SCITECH_DESKTOP>',  target_folder) 
'echo Moving SDD folder to Applications folder rc = 'rc'     >> 'product_log
rc = SysMoveObject('<NS46_FOLDER>',      target_folder) 
'echo Moving NS folder to Applications folder rc = 'rc'      >> 'product_log
rc = SysMoveObject('<FI_JAVA_UNINSTALL>',target_folder) 
'echo Moving Java uninst prg to Applications folder rc = 'rc'>> 'product_log
rc = SysMoveObject('<INNOTEK_FLASH>',    target_folder) 
'echo Moving Flash Player to Applications folder rc = 'rc'   >> 'product_log
rc = SysMoveObject('<WC_WEBEX_FOLD>',    target_folder) 
'echo Moving Web Explorer to Applications folder rc = 'rc'   >> 'product_log
rc = SysMoveObject('<OS/2-Commander>',   target_folder) 
'echo Moving OS/2 Commander to Applications folder rc = 'rc' >> 'product_log
rc = SysMoveObject('<XFREE86OS2>',       target_folder) 
'echo Moving XFree86 to Applications folder rc = 'rc'        >> 'product_log
rc = SysMoveObject('<XWP_MAINFLDR>',     target_folder) 
'echo Moving XWP to Applications folder rc = 'rc'            >> 'product_log
rc = SysMoveObject('<NBMSFLDR>',         target_folder) 
'echo Moving Amouse to Applications folder rc = 'rc'         >> 'product_log
rc = SysMoveObject('<CDREC2>',         target_folder) 
'echo Moving CDRecord/2 to Applications folder rc = 'rc'     >> 'product_log
rc = SysMoveObject('<PMVIEW20FOLDER>',  target_folder) 
'echo Moving PMView 20 to Applications folder rc = 'rc'      >> 'product_log
rc = SysMoveObject('<PMVIEW30FOLDER>',  target_folder) 
'echo Moving PMView 30 to Applications folder rc = 'rc'      >> 'product_log
rc = SysMoveObject('<SYSBAR2FOLDER>',  target_folder) 
'echo Moving SysBar to Applications folder rc = 'rc'         >> 'product_log
rc = SysMoveObject('<PMM2FOLDER>',  target_folder) 
'echo Moving Pmmail to Applications folder rc = 'rc'         >> 'product_log
rc = SysMoveObject('<EM_emx_0.9d_FOLDER>', target_folder) 
'echo Moving EMX to Applications folder rc = 'rc'            >> 'product_log
rc = SysMoveObject('<MOZILLAFLDR>', target_folder) 
'echo Moving Mozilla to Applications folder rc = 'rc'        >> 'product_log
rc = SysMoveObject('<ODINFOLDER>', target_folder) 
'echo Moving Odin to Applications folder rc = 'rc'           >> 'product_log
rc = SysMoveObject('<OCHAT_FOLDER>', target_folder) 
'echo Moving OpenChat to Applications folder rc = 'rc'       >> 'product_log
rc = SysMoveObject('<GCJAVA>', target_folder) 
'echo Moving GC JAVA to Applications folder rc = 'rc'        >> 'product_log
rc = SysMoveObject('<OS2KITJAVAFOLDER>', target_folder) 
'echo Moving Innotek JAVA to Applications folder rc = 'rc'   >> 'product_log

/* remove junk from config.sys */
/* load config.sys */
cfgfile = target'\config.sys'
i = 1
do while lines(cfgfile)
	l.i = linein(cfgfile)
	i = i+1
end
rc = lineout(cfgfile)
l.0 = i-1
/* update config.sys */
'copy 'cfgfile target'\os2\install\config.psp >> 'product_log
'del 'cfgfile' >> 'product_log
do i = 1 to l.0
	if pos('SET ADDONINS_', l.i) = 0 then rc = lineout(cfgfile, l.i)
end
rc = lineout(cfgfile)

exit

/* uninstall mode */
uninstall:

	nop;

return
